import path from "path";
import { argv } from 'yargs';

const parameters = argv.parameters ? require(path.resolve(argv.parameters)) : {};

const specialArgv = {};

argv._.forEach((arg) => {
  if (arg.indexOf(':') > 0) {
    let argArr = arg.split(':');
    specialArgv[argArr[0]] = argArr[1];
  }
});

const defaultOptions = Object.assign(
  {
    output: {
      path: "../web/static-dist/",
      publicPath: "/static-dist/",
    },
    minChunks: 5,

    commonsChunkFileName: "common",
    entryMainName: "main",
    entryFileName: "index",
    extryCssName: "main",

    nodeModulesDir: path.join("node_modules"),
    fontlimit: 1024,
    imglimit: 1024,
    fontName: "fonts",
    imgName: "img",
    mediaName: "media",
    copyName: "img",
    cpuNumber: 2,
    isNeedCommonChunk: ".is-need-common-chunk",
  }
);

const ignoreModule = specialArgv.ignore ? specialArgv.ignore.split(',') : []
const watchModule = specialArgv.watch ? specialArgv.watch.split(',') : []

const options = Object.assign({}, defaultOptions, {
  output: {
    path: path.resolve('./', defaultOptions.output.path),
    publicPath: defaultOptions.output.publicPath,
  },

  __DEV__: process.env.NODE_ENV === "development",

  __DEV_SERVER_PORT__: 3031,
  __VERBOSE__: false,
  rootDir: path.resolve("./"),
  isBuildAllModule: true,
  isWatchAllModule: true,
  __ANALYZER__: specialArgv.analyzer,
  ignoreModule: ignoreModule.map(item => item.toLowerCase()),
  watchModule: watchModule.map(item => item.toLowerCase()),
});

export default options;
