import express from "express";
import webpack from "webpack";
import WebpackNotifierPlugin from "es-webpack-notifier";
import ProgressBarPlugin from "progress-bar-webpack-plugin";
import middleware from 'webpack-dev-middleware'
import logger from "./config/logger";

// import webpackDevMiddleware from "./config/middleware";
// import options from "./config/options";
import { fsExistsSync } from "./utils";

import baseConfig from "./webpack.base";

const app = express();

const compiler = webpack(baseConfig);

new WebpackNotifierPlugin().apply(compiler);
new ProgressBarPlugin().apply(compiler);

app.use(middleware(compiler));

app.listen(3002, "0.0.0.0", (err) => {
  logger.info(`Express server listening on 3002 in ${app.settings.env} node`);

  if (err) {
    logger.error(err);
  }
});
